// Form1.cpp

#include "stdafx.h"

#include "Form1.h"

#include "Win32.h"

using namespace CrosshairDemo;

System::Void Form1::Form1_Load(System::Object^  sender, System::EventArgs^  e)
{
  Bitmap ^bmpBackground = safe_cast<Bitmap ^>(BackgroundImage);
  ClientSize = bmpBackground->Size;
  m_szClientOffset = Drawing::Size(PointToScreen(Point::Empty) - Drawing::Size(Location));
  m_szTargetOffset = Drawing::Size(63, 63) + m_szClientOffset;
  m_ptToolTipLocation = Point(76, 76) + m_szClientOffset;

  // This way of converting the crosshair bitmap into a clipping region for the form most certainly
  // is terribliy inefficient. At least it's *relatively* easy to comprehend (I think)...

  Drawing::Region ^rgnNew = gcnew Drawing::Region;
  for (int i = 0; i < bmpBackground->Width; ++i)
    for (int j = 0; j < bmpBackground->Height; ++j)
      if (bmpBackground->GetPixel(i, j).A)
        rgnNew->Exclude(Rectangle(Point(i, j) + m_szClientOffset, Drawing::Size(1, 1)));
  rgnNew->Complement(Rectangle(Point(m_szClientOffset), ClientSize));
  Region = rgnNew;
}

System::Void Form1::Form1_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e)
{
  if (e->Button == Windows::Forms::MouseButtons::Left) {
    m_bDragging = true;
    m_ptLastMousePos = e->Location;
  }
}

System::Void Form1::Form1_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e)
{
  if (e->Button == Windows::Forms::MouseButtons::Left)
    m_bDragging = false;
}

System::Void Form1::Form1_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e)
{
  if (m_bDragging)
    Location += Drawing::Size(e->Location.X - m_ptLastMousePos.X, e->Location.Y - m_ptLastMousePos.Y);
}

System::Void Form1::Form1_Move(System::Object^  sender, System::EventArgs^  e)
{
  Point ptTarget = Location + m_szTargetOffset;
  IntPtr ipHwndTarget = Win32::WindowFromPoint(ptTarget);
  toolTip1->Show(String::Format("Screen location: {0}\nWindow handle: 0x{1:X8}\nTitle: {2}",
    ptTarget, ipHwndTarget.ToInt32(), Win32::GetWindowText(ipHwndTarget)),
    this, m_ptToolTipLocation, 5000);
}
