// Win32.cpp
// Wrapper for native Win32 API

#include "stdafx.h"

#include <Windows.h>

#include "Win32.h"  // Must be included after <Windows.h> to avoid macro redefinition warning (C4005)

#pragma comment(lib, "user32.lib")

using namespace CrosshairDemo;

IntPtr Win32::WindowFromPoint(Point pt)
{
  POINT ptNative = {pt.X, pt.Y};
  return (IntPtr)::WindowFromPoint(ptNative);
}

String ^Win32::GetWindowText_(IntPtr ipHwnd)
{
  int nStringSize = ::GetWindowTextLength((HWND)(void *)ipHwnd);
  if (!nStringSize)
    return nullptr;  // Error exit
  LPTSTR lpNativeText = new TCHAR[++nStringSize];
  if (!::GetWindowText((HWND)(void *)ipHwnd, lpNativeText, nStringSize)) {
    delete [] lpNativeText;
    return nullptr;  // Error exit
  }
  String ^strText = gcnew String(lpNativeText);
  delete [] lpNativeText;
  return strText;
}
